## hyprland 0.52.1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.30)

# Get version
file(READ "${CMAKE_SOURCE_DIR}/VERSION" VER_RAW)
string(STRIP ${VER_RAW} VER)

project(
  Hyprland
  DESCRIPTION "A Modern C++ Wayland Compositor"
  VERSION ${VER})

include(CTest)
include(CheckIncludeFile)
include(GNUInstallDirs)

set(HYPRLAND_VERSION ${VER})
set(PREFIX ${CMAKE_INSTALL_PREFIX})
set(INCLUDEDIR ${CMAKE_INSTALL_INCLUDEDIR})
set(BINDIR ${CMAKE_INSTALL_BINDIR})
configure_file(hyprland.pc.in hyprland.pc @ONLY)

set(CMAKE_MESSAGE_LOG_LEVEL "STATUS")

message(STATUS "Gathering git info")

# Make shader files includable
execute_process(COMMAND ./scripts/generateShaderIncludes.sh
                WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

find_package(PkgConfig REQUIRED)

# Try to find canihavesomecoffee's udis86 using pkgconfig vmd/udis86 does not
# provide a .pc file and won't be detected this way
pkg_check_modules(udis_dep IMPORTED_TARGET udis86>=1.7.2)

# Fallback to subproject
if(NOT udis_dep_FOUND)
  add_subdirectory("subprojects/udis86")
  include_directories("subprojects/udis86")
  message(STATUS "udis86 dependency not found, falling back to subproject")
endif()

if(CMAKE_BUILD_TYPE)
  string(TOLOWER ${CMAKE_BUILD_TYPE} BUILDTYPE_LOWER)
  if(BUILDTYPE_LOWER STREQUAL "release")
    # Pass.
  elseif(BUILDTYPE_LOWER STREQUAL "debug")
    # Pass.
  elseif(BUILDTYPE_LOWER STREQUAL "relwithdebinfo")
    set(BUILDTYPE_LOWER "debugoptimized")
  elseif(BUILDTYPE_LOWER STREQUAL "minsizerel")
    set(BUILDTYPE_LOWER "minsize")
  elseif(BUILDTYPE_LOWER STREQUAL "none")
    set(BUILDTYPE_LOWER "plain")
  else()
    set(BUILDTYPE_LOWER "release")
  endif()
else()
  set(BUILDTYPE_LOWER "release")
endif()

pkg_get_variable(WAYLAND_PROTOCOLS_DIR wayland-protocols pkgdatadir)
message(STATUS "Found wayland-protocols at ${WAYLAND_PROTOCOLS_DIR}")
pkg_get_variable(WAYLAND_SCANNER_PKGDATA_DIR wayland-scanner pkgdatadir)
message(
  STATUS "Found wayland-scanner pkgdatadir at ${WAYLAND_SCANNER_PKGDATA_DIR}")

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
  message(STATUS "Configuring Hyprland in Debug with CMake")
  add_compile_definitions(HYPRLAND_DEBUG)
else()
  add_compile_options(-O3)
  message(STATUS "Configuring Hyprland in Release with CMake")
endif()

add_compile_definitions(HYPRLAND_VERSION="${HYPRLAND_VERSION}")

include_directories(. "src/" "protocols/")

set(CMAKE_CXX_STANDARD 26)
set(CXX_STANDARD_REQUIRED ON)
add_compile_options(
  -Wall
  -Wextra
  -Wpedantic
  -Wno-unused-parameter
  -Wno-unused-value
  -Wno-missing-field-initializers
  -Wno-gnu-zero-variadic-macro-arguments
  -Wno-narrowing
  -Wno-pointer-arith
  -Wno-clobbered
  -fmacro-prefix-map=${CMAKE_SOURCE_DIR}/=)

# disable lto as it may break plugins
add_compile_options(-fno-lto)

set(CMAKE_EXECUTABLE_ENABLE_EXPORTS TRUE)
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

message(STATUS "Checking deps...")

find_package(Threads REQUIRED)

set(GLES_VERSION "GLES3")
find_package(OpenGL REQUIRED COMPONENTS ${GLES_VERSION})

pkg_check_modules(aquamarine_dep REQUIRED IMPORTED_TARGET aquamarine>=0.9.3)
pkg_check_modules(hyprlang_dep REQUIRED IMPORTED_TARGET hyprlang>=0.3.2)
pkg_check_modules(hyprcursor_dep REQUIRED IMPORTED_TARGET hyprcursor>=0.1.7)
pkg_check_modules(hyprutils_dep REQUIRED IMPORTED_TARGET hyprutils>=0.8.2)
pkg_check_modules(hyprgraphics_dep REQUIRED IMPORTED_TARGET hyprgraphics>=0.1.6)

string(REPLACE "." ";" AQ_VERSION_LIST ${aquamarine_dep_VERSION})
list(GET AQ_VERSION_LIST 0 AQ_VERSION_MAJOR)
list(GET AQ_VERSION_LIST 1 AQ_VERSION_MINOR)
list(GET AQ_VERSION_LIST 2 AQ_VERSION_PATCH)

set(AQUAMARINE_VERSION "${aquamarine_dep_VERSION}")
set(AQUAMARINE_VERSION_MAJOR "${AQ_VERSION_MAJOR}")
set(AQUAMARINE_VERSION_MINOR "${AQ_VERSION_MINOR}")
set(AQUAMARINE_VERSION_PATCH "${AQ_VERSION_PATCH}")
set(HYPRLANG_VERSION "${hyprlang_dep_VERSION}")
set(HYPRUTILS_VERSION "${hyprutils_dep_VERSION}")
set(HYPRCURSOR_VERSION "${hyprcursor_dep_VERSION}")
set(HYPRGRAPHICS_VERSION "${hyprgraphics_dep_VERSION}")


find_package(Git QUIET)

set(GIT_COMMIT_HASH "unknown")
set(GIT_BRANCH "unknown")
set(GIT_COMMIT_MESSAGE "unknown")
set(GIT_COMMIT_DATE "unknown")
set(GIT_DIRTY "unknown")
set(GIT_TAG "unknown")
set(GIT_COMMITS "0")

if(Git_FOUND)
  execute_process(
    COMMAND ${GIT_EXECUTABLE} rev-parse --show-toplevel
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_TOPLEVEL
    OUTPUT_STRIP_TRAILING_WHITESPACE
    ERROR_QUIET
    RESULT_VARIABLE GIT_TOPLEVEL_RESULT
  )

  if(GIT_TOPLEVEL_RESULT EQUAL 0)
    message(STATUS "Detected git repository root: ${GIT_TOPLEVEL}")

    execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
      WORKING_DIRECTORY ${GIT_TOPLEVEL}
      OUTPUT_VARIABLE GIT_COMMIT_HASH OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${GIT_EXECUTABLE} branch --show-current
      WORKING_DIRECTORY ${GIT_TOPLEVEL}
      OUTPUT_VARIABLE GIT_BRANCH OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${GIT_EXECUTABLE} show -s --format=%s
      WORKING_DIRECTORY ${GIT_TOPLEVEL}
      OUTPUT_VARIABLE GIT_COMMIT_MESSAGE OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${GIT_EXECUTABLE} show -s --format=%cd --date=local
      WORKING_DIRECTORY ${GIT_TOPLEVEL}
      OUTPUT_VARIABLE GIT_COMMIT_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${GIT_EXECUTABLE} diff-index --quiet HEAD --
      WORKING_DIRECTORY ${GIT_TOPLEVEL}
      RESULT_VARIABLE GIT_DIRTY_RESULT)
    if(NOT GIT_DIRTY_RESULT EQUAL 0)
      set(GIT_DIRTY "dirty")
    else()
      set(GIT_DIRTY "clean")
    endif()
    execute_process(COMMAND ${GIT_EXECUTABLE} describe --tags
      WORKING_DIRECTORY ${GIT_TOPLEVEL}
      OUTPUT_VARIABLE GIT_TAG OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${GIT_EXECUTABLE} rev-list --count HEAD
      WORKING_DIRECTORY ${GIT_TOPLEVEL}
      OUTPUT_VARIABLE GIT_COMMITS OUTPUT_STRIP_TRAILING_WHITESPACE)
  else()
    message(WARNING "No Git repository detected in ${CMAKE_SOURCE_DIR}")
  endif()
endif()

configure_file(
    ${CMAKE_SOURCE_DIR}/src/version.h.in
    ${CMAKE_SOURCE_DIR}/src/version.h
    @ONLY
)

set_source_files_properties(${CMAKE_SOURCE_DIR}/src/version.h PROPERTIES GENERATED TRUE)

pkg_check_modules(
  deps
  REQUIRED
  IMPORTED_TARGET
  xkbcommon
  uuid
  wayland-server>=1.22.90
  wayland-protocols>=1.45
  cairo
  pango
  pangocairo
  pixman-1
  xcursor
  libdrm
  libinput>=1.28
  gbm
  gio-2.0
  re2)

find_package(hyprwayland-scanner 0.3.10 REQUIRED)

file(GLOB_RECURSE SRCFILES "src/*.cpp")

set(TRACY_CPP_FILES "")
if(USE_TRACY)
  set(TRACY_CPP_FILES "subprojects/tracy/public/TracyClient.cpp")
  message(STATUS "Tracy enabled, TRACY_CPP_FILES: " ${TRACY_CPP_FILES})
endif()

add_executable(Hyprland ${SRCFILES} ${TRACY_CPP_FILES})

set(USE_GPROF OFF)

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
  message(STATUS "Setting debug flags")

  if(WITH_ASAN)
    message(STATUS "Enabling ASan")

    target_link_libraries(Hyprland asan)
    target_compile_options(Hyprland PUBLIC -fsanitize=address)
  endif()

  if(USE_TRACY)
    message(STATUS "Tracy is turned on")

    option(TRACY_ENABLE "" ON)
    option(TRACY_ON_DEMAND "" ON)
    add_subdirectory(subprojects/tracy)

    target_link_libraries(Hyprland Tracy::TracyClient)

    if(USE_TRACY_GPU)
      message(STATUS "Tracy GPU Profiling is turned on")
      add_compile_definitions(USE_TRACY_GPU)
    endif()
  endif()

  add_compile_options(-fno-pie -fno-builtin)
  add_link_options(-no-pie -fno-builtin)
  if(USE_GPROF)
    add_compile_options(-pg)
    add_link_options(-pg)
  endif()
endif()

check_include_file("execinfo.h" EXECINFOH)
if(EXECINFOH)
  message(STATUS "Configuration supports execinfo")
  add_compile_definitions(HAS_EXECINFO)
endif()

include(CheckLibraryExists)
check_library_exists(execinfo backtrace "" HAVE_LIBEXECINFO)
if(HAVE_LIBEXECINFO)
  target_link_libraries(Hyprland execinfo)
endif()

check_include_file("sys/timerfd.h" HAS_TIMERFD)
pkg_check_modules(epoll IMPORTED_TARGET epoll-shim)
if(NOT HAS_TIMERFD AND epoll_FOUND)
  target_link_libraries(Hyprland PkgConfig::epoll)
endif()

check_include_file("sys/inotify.h" HAS_INOTIFY)
pkg_check_modules(inotify IMPORTED_TARGET libinotify)
if(NOT HAS_INOTIFY AND inotify_FOUND)
  target_link_libraries(Hyprland PkgConfig::inotify)
endif()

if(NO_XWAYLAND)
  message(STATUS "Using the NO_XWAYLAND flag, disabling XWayland!")
  add_compile_definitions(NO_XWAYLAND)
else()
  message(STATUS "XWAYLAND Enabled (NO_XWAYLAND not defined) checking deps...")
  pkg_check_modules(
    xdeps
    REQUIRED
    IMPORTED_TARGET
    xcb
    xcb-render
    xcb-xfixes
    xcb-icccm
    xcb-composite
    xcb-res
    xcb-errors)
  target_link_libraries(Hyprland PkgConfig::xdeps)
endif()

if(NO_SYSTEMD)
  message(STATUS "SYSTEMD support is disabled...")
else()
  message(STATUS "SYSTEMD support is requested (NO_SYSTEMD not defined)...")
  add_compile_definitions(USES_SYSTEMD)

  # session file -uwsm
  if(NO_UWSM)
    message(STATUS "UWSM support is disabled...")
  else()
    message(STATUS "UWSM support is enabled (NO_UWSM not defined)...")
    install(FILES ${CMAKE_SOURCE_DIR}/systemd/hyprland-uwsm.desktop
            DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/wayland-sessions)
  endif()
endif()

set(CPACK_PROJECT_NAME ${PROJECT_NAME})
set(CPACK_PROJECT_VERSION ${PROJECT_VERSION})
include(CPack)

if(CMAKE_DISABLE_PRECOMPILE_HEADERS)
  message(STATUS "Not using precompiled headers")
else()
  message(STATUS "Setting precompiled headers")
  target_precompile_headers(Hyprland PRIVATE
                            $<$<COMPILE_LANGUAGE:CXX>:src/pch/pch.hpp>)
endif()

message(STATUS "Setting link libraries")

target_link_libraries(
  Hyprland
  rt
  PkgConfig::aquamarine_dep
  PkgConfig::hyprlang_dep
  PkgConfig::hyprutils_dep
  PkgConfig::hyprcursor_dep
  PkgConfig::hyprgraphics_dep
  PkgConfig::deps)
if(udis_dep_FOUND)
  target_link_libraries(Hyprland PkgConfig::udis_dep)
else()
  target_link_libraries(Hyprland libudis86)
endif()

# used by `make installheaders`, to ensure the headers are generated
add_custom_target(generate-protocol-headers)

function(protocolnew protoPath protoName external)
  if(external)
    set(path ${protoPath})
  else()
    set(path ${WAYLAND_PROTOCOLS_DIR}/${protoPath})
  endif()
  add_custom_command(
    OUTPUT ${CMAKE_SOURCE_DIR}/protocols/${protoName}.cpp
           ${CMAKE_SOURCE_DIR}/protocols/${protoName}.hpp
    COMMAND hyprwayland-scanner ${path}/${protoName}.xml
            ${CMAKE_SOURCE_DIR}/protocols/
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  target_sources(Hyprland PRIVATE protocols/${protoName}.cpp
                                  protocols/${protoName}.hpp)
  target_sources(generate-protocol-headers
                 PRIVATE ${CMAKE_SOURCE_DIR}/protocols/${protoName}.hpp)
endfunction()
function(protocolWayland)
  add_custom_command(
    OUTPUT ${CMAKE_SOURCE_DIR}/protocols/wayland.cpp
           ${CMAKE_SOURCE_DIR}/protocols/wayland.hpp
    COMMAND
      hyprwayland-scanner --wayland-enums
      ${WAYLAND_SCANNER_PKGDATA_DIR}/wayland.xml ${CMAKE_SOURCE_DIR}/protocols/
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  target_sources(Hyprland PRIVATE protocols/wayland.cpp protocols/wayland.hpp)
  target_sources(generate-protocol-headers
                 PRIVATE ${CMAKE_SOURCE_DIR}/protocols/wayland.hpp)
endfunction()

target_link_libraries(Hyprland OpenGL::EGL OpenGL::GL Threads::Threads)

pkg_check_modules(hyprland_protocols_dep hyprland-protocols>=0.6.4)
if(hyprland_protocols_dep_FOUND)
  pkg_get_variable(HYPRLAND_PROTOCOLS hyprland-protocols pkgdatadir)
  message(STATUS "hyprland-protocols dependency set to ${HYPRLAND_PROTOCOLS}")
else()
  set(HYPRLAND_PROTOCOLS "subprojects/hyprland-protocols")
  message(STATUS "hyprland-protocols subproject set to ${HYPRLAND_PROTOCOLS}")
endif()

protocolnew("${HYPRLAND_PROTOCOLS}/protocols" "hyprland-global-shortcuts-v1"
            true)

=== Makefile ===
PREFIX = /usr/local

stub:
	@echo "Do not run $(MAKE) directly without any arguments. Please refer to the wiki on how to compile Hyprland."

release:
	cmake --no-warn-unused-cli -DCMAKE_BUILD_TYPE:STRING=Release -DCMAKE_INSTALL_PREFIX:STRING=${PREFIX} -S . -B ./build
	cmake --build ./build --config Release --target all -j`nproc 2>/dev/null || getconf NPROCESSORS_CONF`

debug:
	cmake --no-warn-unused-cli -DCMAKE_BUILD_TYPE:STRING=Debug -DTESTS=true -DCMAKE_INSTALL_PREFIX:STRING=${PREFIX} -S . -B ./build
	cmake --build ./build --config Debug --target all -j`nproc 2>/dev/null || getconf NPROCESSORS_CONF`

nopch:
	cmake --no-warn-unused-cli -DCMAKE_BUILD_TYPE:STRING=Release -DCMAKE_INSTALL_PREFIX:STRING=${PREFIX} -DCMAKE_DISABLE_PRECOMPILE_HEADERS=ON -S . -B ./build
	cmake --build ./build --config Release --target all -j`nproc 2>/dev/null || getconf NPROCESSORS_CONF`

clear:
	rm -rf build
	rm -f ./protocols/*.h ./protocols/*.c ./protocols/*.cpp ./protocols/*.hpp

all:
	$(MAKE) clear
	$(MAKE) release

install:
	cmake --install ./build

uninstall:
	xargs rm < ./build/install_manifest.txt

pluginenv:
	@echo -en "$(MAKE) pluginenv has been deprecated.\nPlease run $(MAKE) all && sudo $(MAKE) installheaders\n"
	@exit 1

installheaders:
	@if [ ! -f ./src/version.h ]; then echo -en "You need to run $(MAKE) all first.\n" && exit 1; fi

	# remove previous headers from hyprpm's dir
	rm -fr ${PREFIX}/include/hyprland
	mkdir -p ${PREFIX}/include/hyprland
	mkdir -p ${PREFIX}/include/hyprland/protocols
	mkdir -p ${PREFIX}/share/pkgconfig

	cmake --build ./build --config Release --target generate-protocol-headers

	find src -type f \( -name '*.hpp' -o -name '*.h' -o -name '*.inc' \) -print0 | cpio --quiet -0dump ${PREFIX}/include/hyprland
	cp ./protocols/*.h* ${PREFIX}/include/hyprland/protocols
	cp ./build/hyprland.pc ${PREFIX}/share/pkgconfig
	if [ -d /usr/share/pkgconfig ]; then cp ./build/hyprland.pc /usr/share/pkgconfig 2>/dev/null || true; fi

	chmod -R 755 ${PREFIX}/include/hyprland
	chmod 755 ${PREFIX}/share/pkgconfig

man:
	pandoc ./docs/Hyprland.1.rst \
		--standalone \
		--variable=header:"Hyprland User Manual" \
		--variable=date:"${DATE}" \
		--variable=section:1 \
		--from rst \
		--to man > ./docs/Hyprland.1

	pandoc ./docs/hyprctl.1.rst \
		--standalone \
		--variable=header:"hyprctl User Manual" \
		--variable=date:"${DATE}" \
		--variable=section:1 \
		--from rst \
		--to man > ./docs/hyprctl.1

asan:
	@echo -en "!!WARNING!!\nOnly run this in the TTY.\n"
	@pidof Hyprland > /dev/null && echo -ne "Refusing to run with Hyprland running.\n" || echo ""
	@pidof Hyprland > /dev/null && exit 1 || echo ""

	rm -rf ./wayland
	#git reset --hard

	@echo -en "If you want to apply a patch, input its path (leave empty for none):\n"
	@read patchvar; \
	 if [ -n "$$patchvar" ]; then patch -p1 < "$$patchvar" || echo ""; else echo "No patch specified"; fi

	git clone --recursive https://gitlab.freedesktop.org/wayland/wayland
	cd wayland && patch -p1 < ../scripts/waylandStatic.diff && meson setup build --buildtype=debug -Db_sanitize=address -Ddocumentation=false && ninja -C build && cd ..
	cp ./wayland/build/src/libwayland-server.a .
	@echo "Wayland done"

	patch -p1 < ./scripts/hyprlandStaticAsan.diff
	cmake --no-warn-unused-cli -DCMAKE_BUILD_TYPE:STRING=Debug -DWITH_ASAN:STRING=True -DUSE_TRACY:STRING=False -DUSE_TRACY_GPU:STRING=False -S . -B ./build -G Ninja
	cmake --build ./build --config Debug --target all
	@echo "Hyprland done"

	ASAN_OPTIONS="detect_odr_violation=0,log_path=asan.log" HYPRLAND_NO_CRASHREPORTER=1 ./build/Hyprland -c ~/.config/hypr/hyprland.conf

test:
	$(MAKE) debug
	./build/hyprtester/hyprtester -c hyprtester/test.conf -b ./build/Hyprland -p hyprtester/plugin/hyprtestplugin.so

=== debian/changelog ===
hyprland (0.52.1+ds-2) unstable; urgency=medium

  [ Julian Sax ]
  * Specify minimum wayland-protocols build-dep version of 1.45.
    Noticed during backporting to trixie, does not build with 1.44
  * Add patch adjusting error message about assets

  [ Chow Loong Jin ]
  * d/patches: Reexport using gbp-pq
  * d/hyprland.install: Don't list all binaries.
    We want to ship all of /usr/bin in the hyprland package, so just list the
    directory. This also resolves an FTBFS in s390x where hyprpm isn't built.
  * d/control: Update build-dep versions

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 18 Nov 2025 18:04:59 +0800

hyprland (0.52.1+ds-1) unstable; urgency=medium

  [ Carl Keinath ]
  * d/clean: make builds reproducible
  * d/copyright: updated copyright holders and files
  * bump Standards-Version to 4.7.2
  * disable hyprpm on big-endian architectures
  * update Homepage field

  [ Chow Loong Jin ]
  * New upstream version 0.52.1+ds (Closes: #1120590)
  * d/control: Bump hyprgraphaics build-dep to match upstream
  * d/patches: Drop upstreamed patches
  * d/patches: Refresh patches
  * d/patches: Fix tests not finding Hyprland binary
  * d/rules: Disable tests

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 18 Nov 2025 11:22:07 +0800

=== debian/control ===
Source: hyprland
Section: x11
Priority: optional
Maintainer: Debian Hyprland Maintainers <team+hyprland@tracker.debian.org>
Uploaders:
 Alan M Varghese (NyxTrail) <alan@digistorm.in>,
 Carl Keinath <carl.keinath@gmail.com>,
 Chow Loong Jin <hyperair@debian.org>
Build-Depends:
 libaquamarine-dev (>= 0.9.3),
 chrpath,
 cmake,
 cpio,
 debhelper-compat (= 13),
 hwdata,
 hyprland-protocols (>= 0.2+20240505),
 hyprwayland-scanner (>= 0.3.10),
 libcairo-dev,
 libdrm-dev,
 libxkbcommon-dev,
 libegl-dev,
 libegl1-mesa-dev,
 libgbm-dev,
 libglaze-dev,
 libgles-dev,
 libhyprlang-dev (>= 0.3.2),
 libhyprcursor-dev (>= 0.1.7),
 libhyprutils-dev (>= 0.8.2),
 libhyprgraphics-dev (>= 0.1.6),
 libinput-dev (>= 1.28),
 libpango1.0-dev,
 libpixman-1-dev,
 libre2-dev,
 libseat-dev,
 libtomlplusplus-dev,
 libudev-dev,
 libudis86-dev (>= 0+20221013),
 libwayland-dev (>= 1.22.90),
 libxcb1-dev,
 libxcb-render0-dev,
 libxcb-xfixes0-dev,
 libxcb-icccm4-dev,
 libxcb-composite0-dev,
 libxcb-res0-dev,
 libxcb-errors-dev,
 meson,
 ninja-build,
 pkgconf,
 wayland-protocols (>= 1.45),
 libxcursor-dev,
 xwayland,
 xxd
Standards-Version: 4.7.2
Homepage: https://hypr.land
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/hyprland-team/hyprland.git
Vcs-Browser: https://salsa.debian.org/hyprland-team/hyprland

Package: hyprland
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 polkitd, binutils, libgl1-mesa-dri
Recommends: xwayland
Description: Dynamic tiling Wayland compositor
 Hyprland is a dynamic tiling Wayland compositor based on
 wlroots that doesn't sacrifice on its looks. It provides
 the latest Wayland features, is highly customizable, has
 all the eyecandy, the most powerful plugins, easy IPC,
 much more QoL stuff than other wlr-based compositors and
 more...

Package: hyprland-backgrounds
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: hyprland
Description: Set of backgrounds packaged with the hyprland Wayland compositor
 Hyprland is a dynamic tiling Wayland compositor based on
 wlroots that doesn't sacrifice on its looks. It provides
 the latest Wayland features, is highly customizable, has
 all the eyecandy, the most powerful plugins, easy IPC,
 much more QoL stuff than other wlr-based compositors and
 more...
 .
 This package contains the backgrounds included with Hyprland.

Package: hyprland-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}
Description: Development files for Hyprland
 Hyprland is a dynamic tiling Wayland compositor based on
 wlroots that doesn't sacrifice on its looks. It provides
 the latest Wayland features, is highly customizable, has
 all the eyecandy, the most powerful plugins, easy IPC,
 much more QoL stuff than other wlr-based compositors and
 more...
 .
 This package contains header files for developing plugins
 for Hyprland.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH_ENDIAN ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)

# export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O2

EXTRA_CMAKE_ARGS = -DBUILD_TESTING=OFF -DBUILD_HYPRTESTER=OFF

ifeq ($(DEB_HOST_ARCH_ENDIAN),big)
    EXTRA_CMAKE_ARGS += -DNO_HYPRPM=1
endif


%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_ARGS)

override_dh_dwz:
	dh_dwz -XHyprland # Skipping dwz, compression not beneficial on Hyprland

## hyprland 0.52.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -155,10 +155,10 @@
     execute_process(COMMAND ${GIT_EXECUTABLE} branch --show-current
       WORKING_DIRECTORY ${GIT_TOPLEVEL}
       OUTPUT_VARIABLE GIT_BRANCH OUTPUT_STRIP_TRAILING_WHITESPACE)
-    execute_process(COMMAND ${GIT_EXECUTABLE} show -s --format=%s
+    execute_process(COMMAND ${GIT_EXECUTABLE} show -s --format=%s --no-show-signature
       WORKING_DIRECTORY ${GIT_TOPLEVEL}
       OUTPUT_VARIABLE GIT_COMMIT_MESSAGE OUTPUT_STRIP_TRAILING_WHITESPACE)
-    execute_process(COMMAND ${GIT_EXECUTABLE} show -s --format=%cd --date=local
+    execute_process(COMMAND ${GIT_EXECUTABLE} show -s --format=%cd --date=local --no-show-signature
       WORKING_DIRECTORY ${GIT_TOPLEVEL}
       OUTPUT_VARIABLE GIT_COMMIT_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
     execute_process(COMMAND ${GIT_EXECUTABLE} diff-index --quiet HEAD --

=== debian/changelog ===
hyprland (0.52.2+ds-1) unstable; urgency=medium

  [ Carl Keinath ]
  * d/clean: add src/version.h
  * d/patches: deterministic shader inclusion order
  * d/rules: add reproducible=+all deb build option
  * Apply Multi-Arch: hint to hyprland-dev
  * d/control: add Recommends: xdg-desktop-portal-hyprland

  [ Chow Loong Jin ]
  * New upstream version 0.52.2+ds
  * d/control: Set Multi-Arch: allowed

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 10 Dec 2025 11:43:26 +0800

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  hyprwayland-scanner (>= 0.3.10),
  libcairo-dev,
  libdrm-dev,
- libxkbcommon-dev,
+ libxkbcommon-dev (>= 1.11.0),
  libegl-dev,
  libegl1-mesa-dev,
  libgbm-dev,
@@ -58,9 +58,12 @@
 
 Package: hyprland
 Architecture: any
+Multi-Arch: allowed
 Depends: ${misc:Depends}, ${shlibs:Depends},
  polkitd, binutils, libgl1-mesa-dri
-Recommends: xwayland
+Recommends:
+ xwayland,
+ xdg-desktop-portal-hyprland,
 Description: Dynamic tiling Wayland compositor
  Hyprland is a dynamic tiling Wayland compositor based on
  wlroots that doesn't sacrifice on its looks. It provides
@@ -86,7 +89,8 @@
 
 Package: hyprland-dev
 Section: libdevel
-Architecture: any
+Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Development files for Hyprland
  Hyprland is a dynamic tiling Wayland compositor based on

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 DEB_HOST_ARCH_ENDIAN ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
 
 # export DH_VERBOSE = 1
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all
 # export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O2

## hyprland 0.53.3%2Bds

=== debian/changelog ===
hyprland (0.53.3+ds-2) unstable; urgency=medium

  * Move dumpabiver compilation into upstream CMakeLists
  * Refresh patches

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 09 Feb 2026 17:08:59 +0800

hyprland (0.53.3+ds-1) unstable; urgency=medium

  * New upstream version 0.53.3+ds (Closes: #1125297)

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 28 Jan 2026 17:23:31 +0800

hyprland (0.53.1+ds-1) UNRELEASED; urgency=medium

  * New upstream version 0.53.1+ds

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 05 Jan 2026 11:37:27 +0800

hyprland (0.53.0+ds-1) UNRELEASED; urgency=medium

  * d/rules: Include buildflags.mk for CXXFLAGS for dumpabiver
  * d/rules: Add CPPFLAGS and LDFLAGS to dumpabiver compilation.
    Should fix blhc pipeline test
  * New upstream version 0.53.0+ds
  * d/control: Update build-deps to match CMakeLists.txt
  * d/patches: Refresh patches
  * d/control: Build-dep on hyprwire-scanner
  * d/dumpabiver.cpp: Fix compilation error
  * d/copyright: Drop paragraphs for deleted files

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 31 Dec 2025 12:25:58 +0800

hyprland (0.52.2+ds-2) unstable; urgency=medium

  [ Carl Keinath ]
  * d/control: generate Provides: from Hyprland ABI at build time

  [ Chow Loong Jin ]
  * d/control:
    - Update package descriptions
    - Make hyprland-dev depend on its included headers
    - Make hyprland-dev depend on the same version of hyprland
    - Build-dep on libssl-dev
  * Improve debian/dumpabiver
    - Directly use __hyprland_api_get_client_hash() and HYPRLAND_API_VERSION
      from upstream instead of copying the code into debian/
    - Hash the hyprland client hash to get a shorter string for the virtual
      package name
    - Add comments into debian-abi-helper to avoid confusion

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 19 Dec 2025 01:05:59 +0800
